
#ifndef PORYGONLANG_EVALUATIONSCOPE_HPP
#define PORYGONLANG_EVALUATIONSCOPE_HPP

#include <unordered_map>
#include <vector>
#include "../EvalValues/EvalValue.hpp"
using namespace Porygon::Binder;

namespace Porygon::Evaluation {
    class EvaluationScope {
        unordered_map<uint32_t, shared_ptr<EvalValue>> *_scriptScope;
        unordered_map<uint64_t, shared_ptr<EvalValue>> _localScope;
    public:
        explicit EvaluationScope(unordered_map<uint32_t, shared_ptr<EvalValue>> *scriptVariables, int deepestScope);

        ~EvaluationScope() = default;

        void CreateVariable(const BoundVariableKey *key, const shared_ptr<EvalValue> &value);

        void SetVariable(const BoundVariableKey *key, const shared_ptr<EvalValue> &value);

        shared_ptr<EvalValue> GetVariable(const BoundVariableKey *key);
    };
}


#endif //PORYGONLANG_EVALUATIONSCOPE_HPP
